var req				= null;
var MAX_IMGS		= 50;
var num_imgs		= 0;
var current_index	= 0;
var current_frame	= 0;
var num_frames		= 3;

var img_urls		= new Array(MAX_IMGS);
var page_urls		= new Array(MAX_IMGS);
var frame_urls		= new Array(num_frames);

var api_key			= "45d5d4b7dff9bc653c8eb3e73271c10c";

var nsid			= null;
var timerInterval	= null;
var randomOrder		= true;
var msgTimeout		= null;
var msgMaxHeight	= 17;
var msgShowTime		= 4000;
var picRefreshTime	= 5000;

var message			= "";

// message elements
var elMsgText		= null;
var elMsgBg			= null;
var elMsg			= null;
var msg_op			= 0.0;

var flickrUsername	= "";
var gotPhotos		= false;

function setup()
{
	elMsgBg		= document.getElementById("msg_bg");
	elMsgText	= document.getElementById("msg_text");
	elMsg		= document.getElementById("msg");
	elFrameSel	= document.getElementById("sel_frame");
	
    createGenericButton(document.getElementById('doneButton'), 'Done', hideBack);
   	elMsgBg.style.height = "0px";

    if (window.widget)
    {
        var searchString = widget.preferenceForKey(createkey("searchString"));
        var frameType	 = widget.preferenceForKey(createkey("frameType"));
		if (searchString && searchString.length > 0)
		{
			document.getElementById("txt_user").value = searchString;
		}

		if (frameType && frameType.length > 0)
		{
			for (i = 0; i < elFrameSel.options.length; i++)
			{
				if (elFrameSel.options[i].value == frameType)
				{
					elFrameSel.selectedIndex = i;
					break;
				}
			}
		}
    }

	updateFrame();
    getPicList();
    
    if (window.widget)
    {
        widget.onshow = onshow;
        widget.onhide = onhide;
        widget.onremove = onremove;
    }
}

function createkey(key)
{
	return widget.identifier + "-" + key;
}

function updateUsernameEcho(name)
{
	var echo = document.getElementById("username_echo");
	
	if (name.length > 20)
		name = name.substr(0, 20) + "...";
		
	echo.innerHTML = name;
}

function onshow() 
{
    if (timerInterval == null && gotPhotos) {
        timerInterval = setInterval(newpic, picRefreshTime);
    }
}

function onhide() 
{
    if (timerInterval != null) {
        clearInterval(timerInterval);
        timerInterval = null;
    }
}

function onremove()
{
	if (window.widget)
	{
		widget.setPreferenceForKey (null, createkey("searchString"));
		widget.setPreferenceForKey (null, createkey("frameType"));
	}
}

function getPicList()
{
	req = new XMLHttpRequest();
	
	var user = document.getElementById("txt_user").value;
	
	req.onreadystatechange = getPhotoList;
	
	if (user.indexOf("@") == -1)
		req.open("GET", "http://www.flickr.com/services/rest/?method=flickr.people.findByUsername&username=" + user + "&api_key=" + api_key);
	else
		req.open("GET", "http://www.flickr.com/services/rest/?method=flickr.people.findByEmail&find_email=" + user + "&api_key=" + api_key);
	req.send();
}

function getPhotoList()
{
	if (req.readyState == 4)
	{
		if (req.status == 200)
		{
			var users = req.responseXML.getElementsByTagName("user");
			if (users.length == 0)
			{
				var u = document.getElementById("txt_user").value;
				if (u.length > 20)
				{
					u = u.substr(0, 20) + "...";
				}
				showMsg("No match found for <strong>" + u + "</strong>");
			}
			else
			{
				if (users.length > 1)
				{
					showError("Found " + users.length +  " users called " + document.getElementById("txt_user").value + "\nTry entering your email address instead.");
				}

				// save username/email as default
				if (window.widget)
				{
					widget.setPreferenceForKey(document.getElementById("txt_user").value, createkey("searchString"));
				}
				nsid = users[0].attributes.getNamedItem("nsid").value;
				
				flickrUsername = users[0].childNodes[1].firstChild.nodeValue;
			
				req.onreadystatechange = parsePhotoList;
				req.open("GET", "http://www.flickr.com/services/rest/?method=flickr.people.getPublicPhotos&per_page=" + MAX_IMGS + "&user_id=" + nsid + "&api_key=" + api_key, true);
				req.send();
			}
		}
		else 
		{
			alert("Status: " + req.status)
        }
	}
}

function parsePhotoList()
{
	if (req.readyState == 4)
	{
		if (req.status == 200)
		{
			var photos = req.responseXML.getElementsByTagName("photo");
					
			num_imgs = photos.length;
			if (num_imgs > 0)
			{
				updateUsernameEcho(flickrUsername);
				gotPhotos = true;
				
				var indices = new Array(num_imgs);
				for (i = 0; i < num_imgs; i++)
				{
					indices[i] = i;
				}
				
				if (document.getElementById("chk_random").checked)
				{
					// randomise indices
					for (i = 0; i < num_imgs; i++)
					{
						var j = Math.floor(Math.random()*num_imgs);
						if (j != i)
						{
							var temp = indices[i];
							indices[i] = indices[j];
							indices[j] = temp;
						}
					}
				}
					
				for (i = 0; i < num_imgs; i++)
				{
					var pic = photos[indices[i]];
					var server_id = pic.attributes.getNamedItem("server").value;
					var id = pic.attributes.getNamedItem("id").value;
					var secret = pic.attributes.getNamedItem("secret").value;
					
					img_urls[i]		= "http://static.flickr.com/" + server_id + "/" + id + "_" + secret + "_s.jpg";
					page_urls[i]	= "http://www.flickr.com/photos/" + nsid + "/" + id + "/";
				}
				for (i = 0; i < num_frames; i++)
				{
					newpic();
				}
				if (timerInterval != null)
					clearInterval(timerInterval);
				timerInterval = setInterval(newpic, picRefreshTime);

			}
			else
			{
				gotPhotos = false;
				showMsg("No photos found for <strong>" + document.getElementById("txt_user").value + "</strong>");
			}
		}
		else
		{
		}
	}
}

function openPic(i)
{
	widget.openURL(frame_urls[i]);
}

function goWebsite(i)
{
	widget.openURL("http://www.widget-foundry.com/");
}

function goPaypal(i)
{
	widget.openURL("https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=simon%40widget-foundry%2ecom&item_name=Flickrframe%20widget&amount=5%2e00&no_shipping=0&no_note=1&tax=0&currency_code=GBP&lc=GB&bn=PP%2dDonationsBF&charset=UTF%2d8");
}

function newpic()
{
	if (gotPhotos)
	{
		var pic = document.getElementById("img" + current_frame);
		pic.src = img_urls[current_index];
		frame_urls[current_frame] = page_urls[current_index];
	
		current_index = (current_index + 1) % num_imgs;
		current_frame = (current_frame + 1) % num_frames;
	}
}

function showMsg(text)
{
	message = "";
	lines = text.split("\n");
	for (i = 0; i < lines.length; i++)
	{
		message = message + lines[i] + "<br/>";
	}
	
	msgMaxHeight = lines.length * 13 + 4;
	
	elMsgText.innerHTML = message;
	elMsgBg.style.height = msgMaxHeight;
	
	msgTimeout = setTimeout(fadeMsgIn, 500);
}

function fadeMsgIn()
{
	msg_op = msg_op + 0.1;
		
	elMsg.style.opacity = msg_op;

	if (msg_op < 1.0)
	{
		msgTimeout = setTimeout("fadeMsgIn()", 50);
	}
	else
	{
		msg_op = 1.0;
		msgTimeout = setTimeout(fadeMsgOut, msgShowTime);
	}
}

function fadeMsgOut()
{
	msg_op = msg_op - 0.1;
	
	elMsg.style.opacity = msg_op;
	
	if (msg_op > 0.0)
	{
		msgTimeout = setTimeout(fadeMsgOut, 50);
	}
	else
	{
		msg_op = 0.0;
		elMsgBg.style.height = 0;
		elMsgText.innerHTML = "";
	}
}

function dismissMsg()
{
	clearTimeout(msgTimeout);
	fadeMsgOut();
}

/* default widget stuff */

function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";

	exitflip(event);
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function updateFrame()
{
	var elFrame = document.getElementById("frame");
	var elFrameChoice = document.getElementById("sel_frame");
	var index = elFrameChoice.selectedIndex;
	var frame = elFrameChoice.options[index].value;
	
	switch (frame)
	{
		case "wood":
			elFrame.src = "frames/wood.png";
			break;
		case "fpink":
			elFrame.src = "frames/flickr_pink.png";
			break;
		case "fblue":
			elFrame.src = "frames/flickr_blue.png";
			break;
		case "flowers":
			elFrame.src = "frames/flowers.png";
			break;
		case "flickr":
			elFrame.src = "frames/flickr.png";
			break;
		default:
			elFrame.src = "Default.png";
			break;	
	}
	
	if (window.widget)
	{
		widget.setPreferenceForKey(frame, createkey("frameType"));
	}
		
}

function hideBack()
{
	updateFrame();
    getPicList();
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}
